#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire100four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire100four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four1004xi           # 100  -    



#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2four1004xi = {
                1:'10x-4y99z',
                2:'10x-96y22z',
                3:'11x-20y97z',
                4:'11x-4y99z',
                5:'12x-20y97z',
                6:'12x-4y99z',
                7:'13x-4y98z',
                8:'14x-20y96z',
                9:'15x-20y96z',
                10:'15x-3y98z',
                11:'15x-96y21z',
                12:'161x-58y102z',
                13:'16x-2y98z',
                14:'16x-39y90z',
                15:'17x-20y96z',
                16:'17x-2y98z',
                17:'18x-1y98z',
                18:'18x-39y89z',
                19:'19x-20y95z',
                20:'19x0y98z',
                21:'20x-95y20z',
                22:'21x-20y95z',
                23:'21x-39y89z',
                24:'22x-19y95z',
                25:'23x-39y88z',
                26:'24x-18y95z',
                27:'25x-94y19z',
                28:'26x-18y94z',
                29:'26x-38y88z',
                30:'26x-56y78z',
                31:'28x-17y94z',
                32:'28x-37y88z',
                33:'29x-16y94z',
                34:'29x-55y77z',
                35:'30x-93y18z',
                36:'31x-14y93z',
                37:'31x-36y87z',
                38:'32x-13y93z',
                39:'33x-35y87z',
                40:'33x-54y76z',
                41:'34x-12y93z',
                42:'35x-10y92z',
                43:'35x-91y17z',
                44:'36x-34y86z',
                45:'36x-53y76z',
                46:'36x-68y62z',
                47:'37x-8y92z',
                48:'38x-33y86z',
                49:'38x-7y91z',
                50:'39x-52y75z',
                51:'39x-5y91z',
                52:'40x-67y61z',
                53:'40x-90y16z',
                54:'41x-31y85z',
                55:'41x-3y91z',
                56:'42x-1y90z',
                57:'42x-50y74z',
                58:'43x-29y84z',
                59:'44x-65y60z',
                60:'44x-88y15z',
                61:'45x-28y84z',
                62:'45x-48y74z',
                63:'47x-26y83z',
                64:'48x-63y60z',
                65:'49x-23y83z',
                66:'49x-46y73z',
                67:'49x-85y14z',
                68:'51x-21y82z',
                69:'51x-44y72z',
                70:'51x-61y59z',
                71:'53x-19y82z',
                72:'53x-83y13z',
                73:'54x-42y72z',
                74:'55x-16y81z',
                75:'55x-59y58z',
                76:'56x-13y81z',
                77:'57x-39y71z',
                78:'58x-10y80z',
                79:'58x-56y57z',
                80:'58x-80y12z',
                81:'59x-7y79z',
                82:'5x-4y99z',
                83:'5x-97y23z',
                84:'60x-37y70z',
                85:'60x-4y79z',
                86:'61x-1y78z',
                87:'62x-34y70z',
                88:'62x-53y56z',
                89:'62x-77y11z',
                90:'64x-31y69z',
                91:'65x-50y56z',
                92:'66x-73y10z',
                93:'67x-28y68z',
                94:'68x-47y55z',
                95:'69x-24y67z',
                96:'6x-19y97z',
                97:'6x-4y99z',
                98:'70x-21y67z',
                99:'70x-70y9z',
                100:'71x-44y54z',
                101:'72x-17y66z',
                102:'74x-14y65z',
                103:'74x-40y53z',
                104:'74x-66y8z',
                105:'75x-10y64z',
                106:'76x-36y52z',
                107:'76x-6y64z',
                108:'77x-2y63z',
                109:'77x-62y7z',
                110:'78x-33y51z',
                111:'80x-58y6z',
                112:'83x-54y5z',
                113:'86x-49y4z',
                114:'89x-45y3z',
                115:'8x-19y97z',
                116:'8x-4y99z',
                117:'91x-40y2z',
                118:'93x-35y1z',
                119:'95x-30y0z',
                120:'96x-25y0z',
                121:'9x-20y97z',
                122:'9x-4y99z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire100four4xi" usage = "target function for charge1004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire100four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE100FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE100FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE100FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE100FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE100FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four1004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE100FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE100FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE100FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four1004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four1004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE100FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE100FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE100FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire100four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                            